From b03ad64f3e2d6add6f59b2d14a8c408f83467dbe Mon Sep 17 00:00:00 2001
From: Carlos O'Donell <carlos@systemhalted.org>
Date: Tue, 17 Apr 2018 14:55:54 -0500
Subject: [PATCH] glibc.spec: Apply patches in logical order.

The following commit removes the requirement for patches to be
placed in 1000, 2000, or 3000 ID blocks depending on their
upstream status. Instead upstream status is documented in the
header of the patch with some semi-standard notation as described
in template.patch. The patches are re-numbered and defined and
applied in the same order. Verified that before and after the
patch that the source tree does not change. The patch definition
is resorted to patch the patch application order.
---
 glibc-c-utf8-locale.patch                |  16 ++++
 glibc-cs-path.patch                      |   9 ++
 glibc-deprecate_libcrypt.patch           |  10 +++
 glibc-fedora-__libc_multiple_libcs.patch |  55 +++++++-----
 glibc-fedora-linux-tcsetattr.patch       |  11 +++
 glibc-fedora-localedata-rh61908.patch    |  11 +++
 glibc-fedora-localedef.patch             |   9 ++
 glibc-fedora-locarchive.patch            |   5 ++
 glibc-fedora-manual-dircategory.patch    |  11 +++
 glibc-fedora-nis-rh188246.patch          |  10 +++
 glibc-fedora-nscd.patch                  |   5 ++
 glibc-fedora-streams-rh436349.patch      |  10 +++
 glibc-nscd-sysconfig.patch               |   7 ++
 glibc-post_upgrade.patch                 |   5 ++
 glibc-rh1070416.patch                    |   9 ++
 glibc-rh1315108.patch                    |  11 +++
 glibc-rh1452750-allocate_once.patch      |   8 ++
 glibc-rh1452750-libidn2.patch            |   7 ++
 glibc-rh697421.patch                     |  11 +++
 glibc-rh741105.patch                     |  11 +++
 glibc-rh819430.patch                     |  13 +++
 glibc-rh827510.patch                     |  12 ++-
 glibc.spec                               | 149 +++++++++----------------------
 template.patch                           |  11 +++
 24 files changed, 287 insertions(+), 129 deletions(-)
 create mode 100644 template.patch

diff --git a/glibc-c-utf8-locale.patch b/glibc-c-utf8-locale.patch
index 7fabf30..7215e15 100644
--- a/glibc-c-utf8-locale.patch
+++ b/glibc-c-utf8-locale.patch
@@ -1,3 +1,19 @@
+Short description: Add C.UTF-8 support.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-submitted
+
+This patch needs to upstream as part of Carlos O'Donell
+<carlos@redhat.com>'s work on enabling upstream C.UTF-8 support. This
+work is currently blocked on cleaning up the test results to prove that
+full code-point sorting is working as intended.
+
+Note that this patch does not provide full code-point sorting as
+expected.
+
+This patch needs to upstream as soon as possible since it would be nice
+to have this in F29 and fixed.
+
 From 2eda7b462b415105f5a05c1323372d4e39d46439 Mon Sep 17 00:00:00 2001
 From: Mike FABIAN <mfabian@redhat.com>
 Date: Mon, 10 Aug 2015 15:58:12 +0200
diff --git a/glibc-cs-path.patch b/glibc-cs-path.patch
index 982f8ff..aafa741 100644
--- a/glibc-cs-path.patch
+++ b/glibc-cs-path.patch
@@ -1,3 +1,12 @@
+Short description: Adjust CS_PATH return value.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-needed
+
+In Fedora we should return only /usr/bin because /bin is just a symlink
+to /usr/bin after MoveToUsr transition (which glibc has not really
+completed).
+
 diff -pruN a/sysdeps/unix/confstr.h b/sysdeps/unix/confstr.h
 --- a/sysdeps/unix/confstr.h	2012-12-25 08:32:13.000000000 +0530
 +++ b/sysdeps/unix/confstr.h	2014-09-05 20:02:55.698275219 +0530
diff --git a/glibc-deprecate_libcrypt.patch b/glibc-deprecate_libcrypt.patch
index ccc7335..698546f 100644
--- a/glibc-deprecate_libcrypt.patch
+++ b/glibc-deprecate_libcrypt.patch
@@ -1,3 +1,13 @@
+Short description: Deprecate libcrypt.
+Author(s): Zack Weinberg <zackw@panix.com>
+Origin: https://sourceware.org/ml/libc-alpha/2017-08/msg01257.html
+Bug-Fedora: #1566464
+Upsteram status: https://patchwork.sourceware.org/patch/22401/
+
+Additionally we need to review:
+https://patchwork.sourceware.org/patch/26750/
+and revisit the issues around bug rhbz1566464.
+
 Background information:
 
 https://sourceware.org/ml/libc-alpha/2017-08/msg01257.html
diff --git a/glibc-fedora-__libc_multiple_libcs.patch b/glibc-fedora-__libc_multiple_libcs.patch
index 8d8e857..256ef20 100644
--- a/glibc-fedora-__libc_multiple_libcs.patch
+++ b/glibc-fedora-__libc_multiple_libcs.patch
@@ -1,26 +1,35 @@
-#
-# Upstream discussions:
-# https://sourceware.org/ml/libc-alpha/2014-02/msg00580.html
-#
-# Based on the following commit:
-#
-# From 16552c01a66633c9e412984d9d92616bd4e5303c Mon Sep 17 00:00:00 2001
-# From: Andreas Schwab <schwab@redhat.com>
-# Date: Fri, 11 Jun 2010 11:04:11 +0200
-# Subject: [PATCH] Properly set __libc_multiple_libcs
-# 
-# * elf/rtld.c (_dl_starting_up): Always define.
-# (dl_main): Always set _dl_starting_up.
-# * elf/dl-support.c (_dl_starting_up): Always define.
-# * elf/dl-init.c (_dl_init): Always clear _dl_starting_up.
-# 
-# ---
-#  ChangeLog        |    7 +++++++
-#  elf/dl-init.c    |    4 ----
-#  elf/dl-support.c |    2 --
-#  elf/rtld.c       |    4 ----
-#  4 files changed, 7 insertions(+), 10 deletions(-)
-# 
+Short description: Cleanup use of _dl_starting_up.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: https://sourceware.org/ml/libc-alpha/2014-02/msg00589.html
+
+Upstream discussions:
+https://sourceware.org/ml/libc-alpha/2014-02/msg00580.html
+
+Based on the following commit:
+~~~
+From 16552c01a66633c9e412984d9d92616bd4e5303c Mon Sep 17 00:00:00 2001
+From: Andreas Schwab <schwab@redhat.com>
+Date: Fri, 11 Jun 2010 11:04:11 +0200
+Subject: [PATCH] Properly set __libc_multiple_libcs
+
+	* elf/rtld.c (_dl_starting_up): Always define.
+	(dl_main): Always set _dl_starting_up.
+	* elf/dl-support.c (_dl_starting_up): Always define.
+	* elf/dl-init.c (_dl_init): Always clear _dl_starting_up.
+
+---
+ChangeLog        |    7 +++++++
+elf/dl-init.c    |    4 ----
+elf/dl-support.c |    2 --
+elf/rtld.c       |    4 ----
+4 files changed, 7 insertions(+), 10 deletions(-)
+~~~
+
+This patch needs to go upstream to get cleaned up, but has always involed
+analysis of the GNU/Hurd parts of the change and that stalled out, but
+perhaps with build-many-glibcs we can now test these changes more easily.
+
 Index: b/elf/dl-init.c
 ===================================================================
 --- a/elf/dl-init.c
diff --git a/glibc-fedora-linux-tcsetattr.patch b/glibc-fedora-linux-tcsetattr.patch
index b47e23e..3ae7e27 100644
--- a/glibc-fedora-linux-tcsetattr.patch
+++ b/glibc-fedora-linux-tcsetattr.patch
@@ -1,3 +1,14 @@
+Short description: Fedora-specific workaround for kernel pty bug.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-submitted
+
+This is a Fedora-specific workaround for a kernel bug where calling
+ioctl on a pty will silently ignore the invalid c_cflag. The
+workaround is to use TCGETS to verify the setting matches. This is
+not upstream and needs to either be removed or submitted upstream
+after analysis.
+
 Index: b/sysdeps/unix/sysv/linux/tcsetattr.c
 ===================================================================
 --- a/sysdeps/unix/sysv/linux/tcsetattr.c
diff --git a/glibc-fedora-localedata-rh61908.patch b/glibc-fedora-localedata-rh61908.patch
index c8fee0f..518253d 100644
--- a/glibc-fedora-localedata-rh61908.patch
+++ b/glibc-fedora-localedata-rh61908.patch
@@ -1,3 +1,14 @@
+Short description: Add 4 ISO-8859-15 locales to SUPPORTED for Euro symbol.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-RHEL: #61908
+Upstream status: not-needed
+
+Very early RHL 7.3 requirement to add these locales so users can
+get access to Euro symbol. We should review this bug and decide if
+the UTF-8 locales are now serving the same purpose and drop the
+additional locales.
+
 * Tue Mar 26 2002 Jakub Jelinek <jakub@redhat.com> 2.2.5-28
 - add a couple of .ISO-8859-15 locales (#61908)
 
diff --git a/glibc-fedora-localedef.patch b/glibc-fedora-localedef.patch
index 4aaec7f..787951f 100644
--- a/glibc-fedora-localedef.patch
+++ b/glibc-fedora-localedef.patch
@@ -1,3 +1,12 @@
+Short description: Fedora-specific glibc install locale changes.
+Author(s):  Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-needed
+
+The Fedora glibc build and install does not need the normal install
+behaviour which updates the locale archive. The Fedora install phase
+in the spec file of the rpm will handle this manually.
+
 diff --git a/localedata/Makefile b/localedata/Makefile
 index a5f3c92d58954dfc..56719c7c714aa0f1 100644
 --- a/localedata/Makefile
diff --git a/glibc-fedora-locarchive.patch b/glibc-fedora-locarchive.patch
index 91ac661..299b0f0 100644
--- a/glibc-fedora-locarchive.patch
+++ b/glibc-fedora-locarchive.patch
@@ -1,3 +1,8 @@
+Short description: Allow access to internal locale archive functions.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-needed
+
 This is a part of commit glibc-2.3.3-1492-ga891c7b,
 needed for fedora/build-locale-archive.c only.
 
diff --git a/glibc-fedora-manual-dircategory.patch b/glibc-fedora-manual-dircategory.patch
index f681620..11c2656 100644
--- a/glibc-fedora-manual-dircategory.patch
+++ b/glibc-fedora-manual-dircategory.patch
@@ -1,3 +1,14 @@
+Short description: Place glibc info into "Libraries" category.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-needed
+
+The category names for libraries is completely random including
+"Libraries", "GNU Libraries", "GNU libraries", and "Software libraries."
+In the GNU info manual the "Software libraries" category is given as an
+example, but really we need to standardize on a category for upstream.
+I suggest we drop this change after some upstream discussion.
+
 From 4820b9175535e13df79ce816106016040014916e Mon Sep 17 00:00:00 2001
 From: Jakub Jelinek <jakub@redhat.com>
 Date: Fri, 3 Nov 2006 16:31:21 +0000
diff --git a/glibc-fedora-nis-rh188246.patch b/glibc-fedora-nis-rh188246.patch
index 9389901..5ec2237 100644
--- a/glibc-fedora-nis-rh188246.patch
+++ b/glibc-fedora-nis-rh188246.patch
@@ -1,3 +1,13 @@
+Short description: Fedora-specific enabling batch read in NSS.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-RHEL: #188246
+Upstream status: not-submitted
+
+Enable batch read in NSS. It's not clear if this is always a win or
+just a win for NIS+, this needs to be analyzed and sent upstream or
+removed.
+
 From baba5d9461d4e8a581ac26fe4412ad783ffc73e7 Mon Sep 17 00:00:00 2001
 From: Jakub Jelinek <jakub@redhat.com>
 Date: Mon, 1 May 2006 08:02:53 +0000
diff --git a/glibc-fedora-nscd.patch b/glibc-fedora-nscd.patch
index c0c464d..6f8f764 100644
--- a/glibc-fedora-nscd.patch
+++ b/glibc-fedora-nscd.patch
@@ -1,3 +1,8 @@
+Short description: NSCD must use nscd user.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-needed
+
 Fedora-specific configuration adjustment to introduce the nscd user.
 (Upstream does not assume this user exists.)
 
diff --git a/glibc-fedora-streams-rh436349.patch b/glibc-fedora-streams-rh436349.patch
index 9334f19..0d8f7d9 100644
--- a/glibc-fedora-streams-rh436349.patch
+++ b/glibc-fedora-streams-rh436349.patch
@@ -1,3 +1,13 @@
+Short description: Do not define _XOPEN_STREAMS.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-Fedora: #436349
+Upstream status: not-submitted
+
+This patch should go upstream. Not defining _XOPEN_STREAMS is the
+same as setting it to -1 for POSIX conformance. The headers setting
+needs to be reviewed indepedently.
+
 This is part of commit glibc-2.3.3-1564-gd0b6ac6
 
 * Fri Mar 14 2008 Jakub Jelinek <jakub@redhat.com> 2.7.90-11
diff --git a/glibc-nscd-sysconfig.patch b/glibc-nscd-sysconfig.patch
index a00346b..03dee9e 100644
--- a/glibc-nscd-sysconfig.patch
+++ b/glibc-nscd-sysconfig.patch
@@ -1,3 +1,10 @@
+Short description: Provide options to nscd startup.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-needed
+
+Fedora-specific nscd startup configuration file.
+
 diff --git a/nscd/nscd.service b/nscd/nscd.service
 index b7428a3..19ba185 100644
 --- a/nscd/nscd.service
diff --git a/glibc-post_upgrade.patch b/glibc-post_upgrade.patch
index 60baa49..a64adfc 100644
--- a/glibc-post_upgrade.patch
+++ b/glibc-post_upgrade.patch
@@ -1,3 +1,8 @@
+Short description: RPM Post-upgrade cleanup program.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Upstream status: not-needed
+
 A helper program is needed to clean up the system configuration
 early during RPM package installation, so that other scriptlets
 can run successfully.
diff --git a/glibc-rh1070416.patch b/glibc-rh1070416.patch
index 7e4235e..0975e0f 100644
--- a/glibc-rh1070416.patch
+++ b/glibc-rh1070416.patch
@@ -1,3 +1,12 @@
+Short description: Add syslog.target dependency.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-Fedora: #1070416
+Upstream status: not-needed
+
+Fedora-specific changes to the nscd.service file.
+See also: glibc-nscd-sysconfig.patch.
+
 --- a/nscd/nscd.service
 +++ b/nscd/nscd.service
 @@ -2,6 +2,7 @@
diff --git a/glibc-rh1315108.patch b/glibc-rh1315108.patch
index 236307a..a9b3374 100644
--- a/glibc-rh1315108.patch
+++ b/glibc-rh1315108.patch
@@ -1,3 +1,14 @@
+Short description: Remove extend_alloca.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: git://sourceware.org/git/glibc.git/fw/extend_alloca
+Bug-Fedora: #1315108
+Bug-Upstream: #18023
+Upstream status: https://sourceware.org/ml/libc-alpha/2015-03/msg00056.html
+
+Need to review these patches and get them upstream, the last
+status was submission in 2015, followed by some of the patches
+going into upstream.
+
 From the upstream branch fw/extend_alloca.
 
 commit dc79f9aa56933dc8b475209f9a4059965b50ea26
diff --git a/glibc-rh1452750-allocate_once.patch b/glibc-rh1452750-allocate_once.patch
index bdef921..7c613e6 100644
--- a/glibc-rh1452750-allocate_once.patch
+++ b/glibc-rh1452750-allocate_once.patch
@@ -1,3 +1,11 @@
+Short description: Implement allocate_once for internal use.
+Author(s): Istvan Kurucsai <pistukem@gmail.com>
+Origin: PATCH
+Bug-Fedora: #1452750
+Upstream status: https://patchwork.sourceware.org/patch/25361/
+
+Internal allocate_once() function should get pushed upstream.
+
 commit a829b747cf2ce18ba869ea60f67975c484bf2769
 Author: Istvan Kurucsai <pistukem@gmail.com>
 Date:   Fri Jan 12 15:34:13 2018 +0100
diff --git a/glibc-rh1452750-libidn2.patch b/glibc-rh1452750-libidn2.patch
index 4a5171f..782350f 100644
--- a/glibc-rh1452750-libidn2.patch
+++ b/glibc-rh1452750-libidn2.patch
@@ -1,3 +1,10 @@
+Short description: Use libidn2 for IDNA support.
+Author(s): Florian Weimer <fweimer@redhat.com>
+Origin: PATCH
+Bug-Fedora: #1452750
+Bug-Upstream: #19728, #19729, #22247
+Upstream status: https://patchwork.sourceware.org/patch/25764/
+
 commit 0e0929705f095c7eb2e11e82aee3bf9e9edd365e
 Author: Florian Weimer <fweimer@redhat.com>
 Date:   Wed Jan 10 20:03:03 2018 +0100
diff --git a/glibc-rh697421.patch b/glibc-rh697421.patch
index 961c805..e909aa1 100644
--- a/glibc-rh697421.patch
+++ b/glibc-rh697421.patch
@@ -1,3 +1,14 @@
+Short description: Add UCS-2 aliases.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-RHEL: #697421
+Upstream status: https://sourceware.org/ml/libc-alpha/2012-12/msg00103.html
+
+This is a Fedora-specific change to include new aliases for UCS-2
+data for gconv used by a certain class of users. This should be
+revisited at some point to determine if those users are just using
+UTF-8 at this point.
+
 diff -rup a/iconvdata/gconv-modules b/iconvdata/gconv-modules
 --- a/iconvdata/gconv-modules	2010-05-04 05:27:23.000000000 -0600
 +++ b/iconvdata/gconv-modules	2012-01-26 10:58:24.181895489 -0700
diff --git a/glibc-rh741105.patch b/glibc-rh741105.patch
index d9b3752..f7d06ca 100644
--- a/glibc-rh741105.patch
+++ b/glibc-rh741105.patch
@@ -1,3 +1,14 @@
+Short description: Work ld.so --verify crash on debuginfo files.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-RHEL: #741105, #767146
+Upstream status: not-needed
+
+This change is designed to work around running ld.so on a debuginfo
+file. This is the wrong fix for this problem and should be dropped.
+The correct solution is to mark debuginfo files as new types of
+ELF files.
+
 Index: glibc-2.22-386-g95e8397/elf/dl-load.c
 ===================================================================
 --- glibc-2.22-386-g95e8397.orig/elf/dl-load.c
diff --git a/glibc-rh819430.patch b/glibc-rh819430.patch
index b22e421..8b766f1 100644
--- a/glibc-rh819430.patch
+++ b/glibc-rh819430.patch
@@ -1,3 +1,16 @@
+Short description: fnmatch() fails with MBCS.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-RHEL: #819430, #826149, #826151
+Bug-Upstream: #14185
+Upstream status: not-submitted
+
+fnmatch() fails when '*' wildcard is applied on the file name
+containing multi-byte character(s)
+
+This needs to be reviewed thoroughly and go upstream with a
+new test case.
+
 diff -Nrup a/posix/fnmatch.c b/posix/fnmatch.c
 --- a/posix/fnmatch.c	2012-01-01 07:16:32.000000000 -0500
 +++ b/posix/fnmatch.c	2012-05-23 14:14:29.099461189 -0400
diff --git a/glibc-rh827510.patch b/glibc-rh827510.patch
index 7fd3e99..6115891 100644
--- a/glibc-rh827510.patch
+++ b/glibc-rh827510.patch
@@ -1,5 +1,15 @@
-2012-06-14  Jeff Law  <law@redhat.com>
+Short description: Fix newlocale error return.
+Author(s): Fedora glibc team <glibc@lists.fedoraproject.org>
+Origin: PATCH
+Bug-RHEL: #832516
+Bug-Fedora: #827510
+Bug-Upstream: #14247
+Upstream status: not-submitted
+
+This needs to go upstream right away to fix the error case for
+newlocale not correctly returning an error.
 
+2012-06-14  Jeff Law  <law@redhat.com>
 
 	* locale/loadlocale.c (_nl_load_locale): Delay setting
 	file->decided until we have successfully loaded the file's
diff --git a/glibc.spec b/glibc.spec
index 00a0473..02ae033 100644
--- a/glibc.spec
+++ b/glibc.spec
@@ -135,93 +135,32 @@ Source11: SUPPORTED
 Source12: ChangeLog.old
 
 ##############################################################################
-# Start of glibc patches
-##############################################################################
-# 0000-0999 for patches which are unlikely to ever go upstream or which
-# have not been analyzed to see if they ought to go upstream yet.
-#
-# 1000-2000 for patches that are already upstream.
-#
-# 2000-3000 for patches that are awaiting upstream approval
-#
-# Yes, I realize this means some gratutious changes as patches to from
-# one bucket to another, but I find this scheme makes it easier to track
-# the upstream divergence and patches needing approval.
-#
-# Note that we can still apply the patches in any order we see fit, so
-# the changes from one bucket to another won't necessarily result in needing
-# to twiddle the patch because of dependencies on prior patches and the like.
-
-
-##############################################################################
-#
-# Patches that are unlikely to go upstream or not yet analyzed.
-#
-##############################################################################
-
-Patch1: glibc-post_upgrade.patch
-Patch2: glibc-fedora-nscd.patch
-
-# All these were from the glibc-fedora.patch mega-patch and need another
-# round of reviewing.  Ideally they'll either be submitted upstream or
-# dropped.
-Patch0012: glibc-fedora-linux-tcsetattr.patch
-Patch0015: glibc-fedora-localedef.patch
-Patch0019: glibc-fedora-nis-rh188246.patch
-Patch0020: glibc-fedora-manual-dircategory.patch
-Patch0024: glibc-fedora-locarchive.patch
-Patch0025: glibc-fedora-streams-rh436349.patch
-Patch0028: glibc-fedora-localedata-rh61908.patch
-Patch0031: glibc-fedora-__libc_multiple_libcs.patch
-
-# Allow applications to call pthread_atfork without libpthread.so.
-
-Patch0047: glibc-nscd-sysconfig.patch
-
-# confstr _CS_PATH should only return /usr/bin on Fedora since /bin is just a
-# symlink to it.
-Patch0053: glibc-cs-path.patch
-
-# Add C.UTF-8 locale into /usr/lib/locale/
-Patch0059: glibc-c-utf8-locale.patch
-
-##############################################################################
-#
-# Patches from upstream
-#
-##############################################################################
-
-##############################################################################
-#
-# Patches submitted, but not yet approved upstream.
-#
-##############################################################################
-#
-# Each should be associated with a BZ.
-# Obviously we're not there right now, but that's the goal
-#
-
-# http://sourceware.org/ml/libc-alpha/2012-12/msg00103.html
-Patch2007: glibc-rh697421.patch
-
-Patch2013: glibc-rh741105.patch
-
-# Upstream BZ 14247
-Patch2023: glibc-rh827510.patch
-
-# Upstream BZ 14185
-Patch2027: glibc-rh819430.patch
-
-Patch2031: glibc-rh1070416.patch
-
-Patch2037: glibc-rh1315108.patch
-Patch2040: glibc-rh1452750-allocate_once.patch
-Patch2041: glibc-rh1452750-libidn2.patch
-Patch2042: glibc-deprecate_libcrypt.patch
-
-##############################################################################
-# End of glibc patches.
-##############################################################################
+# Patches:
+# - See each individual patch file for origin and upstream status.
+# - For new patches follow template.patch format.
+##############################################################################
+Patch0001: glibc-post_upgrade.patch
+Patch0002: glibc-fedora-nscd.patch
+Patch0003: glibc-rh697421.patch
+Patch0004: glibc-fedora-linux-tcsetattr.patch
+Patch0005: glibc-rh741105.patch
+Patch0006: glibc-fedora-localedef.patch
+Patch0007: glibc-fedora-nis-rh188246.patch
+Patch0008: glibc-fedora-manual-dircategory.patch
+Patch0009: glibc-rh827510.patch
+Patch0010: glibc-fedora-locarchive.patch
+Patch0011: glibc-fedora-streams-rh436349.patch
+Patch0012: glibc-rh819430.patch
+Patch0013: glibc-fedora-localedata-rh61908.patch
+Patch0014: glibc-fedora-__libc_multiple_libcs.patch
+Patch0015: glibc-rh1070416.patch
+Patch0016: glibc-nscd-sysconfig.patch
+Patch0017: glibc-cs-path.patch
+Patch0018: glibc-c-utf8-locale.patch
+Patch0019: glibc-rh1315108.patch
+Patch0020: glibc-rh1452750-allocate_once.patch
+Patch0021: glibc-rh1452750-libidn2.patch
+Patch0022: glibc-deprecate_libcrypt.patch
 
 ##############################################################################
 # Continued list of core "glibc" package information:
@@ -721,28 +660,28 @@ microbenchmark tests on the system.
 %setup -q -n %{glibcsrcdir}
 
 # Patch order matters.
-%patch1 -p1
-%patch2 -p1
-%patch2007 -p1
+%patch0001 -p1
+%patch0002 -p1
+%patch0003 -p1
+%patch0004 -p1
+%patch0005 -p1
+%patch0006 -p1
+%patch0007 -p1
+%patch0008 -p1
+%patch0009 -p1
+%patch0010 -p1
+%patch0011 -p1
 %patch0012 -p1
-%patch2013 -p1
+%patch0013 -p1
+%patch0014 -p1
 %patch0015 -p1
+%patch0016 -p1
+%patch0017 -p1
+%patch0018 -p1
 %patch0019 -p1
 %patch0020 -p1
-%patch2023 -p1
-%patch0024 -p1
-%patch0025 -p1
-%patch2027 -p1
-%patch0028 -p1
-%patch0031 -p1
-%patch2031 -p1
-%patch0047 -p1
-%patch0053 -p1
-%patch0059 -p1
-%patch2037 -p1
-%patch2040 -p1
-%patch2041 -p1
-%patch2042 -p1
+%patch0021 -p1
+%patch0022 -p1
 
 ##############################################################################
 # %%prep - Additional prep required...
diff --git a/template.patch b/template.patch
new file mode 100644
index 0000000..10ec35e
--- /dev/null
+++ b/template.patch
@@ -0,0 +1,11 @@
+Short description: <Short description>
+Author(s): <Who wrote them. Comma separated.>
+Origin: <Source repo(s) where it came from or keyword "PATCH" if this is simply a patch>
+# Likely git://sourceware.org/git/glibc.git
+Bug-RHEL: <Rhel bug #'s, comma separated e.g. #XXX, #YYY, #ZZZ>
+Bug-Fedora: <Fedora bug #'s, comma separated e.g. #XXX, #YYY, #ZZZ>
+Bug-Upstream: <Upstream bug#'s, comma separated e.g. #XXX, #YYY, #ZZZ>
+Upstream status: <[Patchwork URL|libc-alpha URL|not-needed|not-submitted|committed] for each commit>
+# <Additional descriptive text follows 'Upstream status:' line>
+<If upstream status == committed then a copy of the upstream commit log follows>
+<Patch>
-- 
2.14.3